(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@sgratzl/chartjs-esm-facade')) :
  typeof define === 'function' && define.amd ? define(['exports', '@sgratzl/chartjs-esm-facade'], factory) :
  (global = global || self, factory(global.ChartGraphs = {}, global.ChartESMFacade));
}(this, (function (exports, chartjsEsmFacade) { 'use strict';

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var classCallCheck = _classCallCheck;

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  var createClass = _createClass;

  function createCommonjsModule(fn, basedir, module) {
  	return module = {
  	  path: basedir,
  	  exports: {},
  	  require: function (path, base) {
        return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);
      }
  	}, fn(module, module.exports), module.exports;
  }

  function commonjsRequire () {
  	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');
  }

  var setPrototypeOf = createCommonjsModule(function (module) {
    function _setPrototypeOf(o, p) {
      module.exports = _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
      };

      return _setPrototypeOf(o, p);
    }

    module.exports = _setPrototypeOf;
  });

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) setPrototypeOf(subClass, superClass);
  }

  var inherits = _inherits;

  var _typeof_1 = createCommonjsModule(function (module) {
    function _typeof(obj) {
      "@babel/helpers - typeof";

      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        module.exports = _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        module.exports = _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }

      return _typeof(obj);
    }

    module.exports = _typeof;
  });

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  var assertThisInitialized = _assertThisInitialized;

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof_1(call) === "object" || typeof call === "function")) {
      return call;
    }

    return assertThisInitialized(self);
  }

  var possibleConstructorReturn = _possibleConstructorReturn;

  var getPrototypeOf = createCommonjsModule(function (module) {
    function _getPrototypeOf(o) {
      module.exports = _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };
      return _getPrototypeOf(o);
    }

    module.exports = _getPrototypeOf;
  });

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  function horizontal(from, to, options) {
    return {
      fx: (to.x - from.x) * options.tension,
      fy: 0,
      tx: (from.x - to.x) * options.tension,
      ty: 0
    };
  }

  function vertical(from, to, options) {
    return {
      fx: 0,
      fy: (to.y - from.y) * options.tension,
      tx: 0,
      ty: (from.y - to.y) * options.tension
    };
  }

  function radial(from, to, options) {
    var angleHelper = Math.hypot(to.x - from.x, to.y - from.y) * options.tension;
    return {
      fx: Number.isNaN(from.angle) ? 0 : Math.cos(from.angle) * angleHelper,
      fy: Number.isNaN(from.angle) ? 0 : Math.sin(from.angle) * -angleHelper,
      tx: Number.isNaN(to.angle) ? 0 : Math.cos(to.angle) * -angleHelper,
      ty: Number.isNaN(to.angle) ? 0 : Math.sin(to.angle) * angleHelper
    };
  }

  var EdgeLine = /*#__PURE__*/function (_Line) {
    inherits(EdgeLine, _Line);

    var _super = _createSuper(EdgeLine);

    function EdgeLine() {
      classCallCheck(this, EdgeLine);

      return _super.apply(this, arguments);
    }

    createClass(EdgeLine, [{
      key: "draw",
      value: function draw(ctx) {
        var options = this.options;
        ctx.save(); // Stroke Line Options

        ctx.lineCap = options.borderCapStyle;
        ctx.setLineDash(options.borderDash || []);
        ctx.lineDashOffset = options.borderDashOffset;
        ctx.lineJoin = options.borderJoinStyle;
        ctx.lineWidth = options.borderWidth;
        ctx.strokeStyle = options.borderColor;
        var orientations = {
          horizontal: horizontal,
          vertical: vertical,
          radial: radial
        };
        var layout = orientations[this._orientation] || orientations.horizontal;

        var renderLine = function renderLine(from, to) {
          var shift = layout(from, to, options);
          var fromX = {
            cpx: from.x + shift.fx,
            cpy: from.y + shift.fy
          };
          var toX = {
            cpx: to.x + shift.tx,
            cpy: to.y + shift.ty
          }; // Line to next point

          if (options.stepped === 'middle') {
            var midpoint = (from.x + to.x) / 2.0;
            ctx.lineTo(midpoint, from.y);
            ctx.lineTo(midpoint, to.y);
            ctx.lineTo(to.x, to.y);
          } else if (options.stepped === 'after') {
            ctx.lineTo(from.x, to.y);
            ctx.lineTo(to.x, to.y);
          } else if (options.stepped) {
            ctx.lineTo(to.x, from.y);
            ctx.lineTo(to.x, to.y);
          } else if (options.tension) {
            ctx.bezierCurveTo(fromX.cpx, fromX.cpy, toX.cpx, toX.cpy, to.x, to.y);
          } else {
            ctx.lineTo(to.x, to.y);
          }

          return to;
        };

        var source = this.source.getProps(['x', 'y', 'angle']);
        var target = this.target.getProps(['x', 'y', 'angle']);
        var points = this.getProps(['points']).points; // Stroke Line

        ctx.beginPath();
        var from = source;
        ctx.moveTo(from.x, from.y);

        if (points && points.length > 0) {
          from = points.reduce(renderLine, from);
        }

        renderLine(from, target);
        ctx.stroke();

        if (options.directed) {
          var to = target; // compute the rotation based on from and to

          var shift = layout(from, to, options);
          var s = options.arrowHeadSize;
          var offset = options.arrowHeadOffset;
          ctx.save();
          ctx.translate(to.x, target.y);

          if (options.stepped === 'middle') {
            var midpoint = (from.x + to.x) / 2.0;
            ctx.rotate(Math.atan2(to.y - to.y, to.x - midpoint));
          } else if (options.stepped === 'after') {
            ctx.rotate(Math.atan2(to.y - to.y, to.x - from.x));
          } else if (options.stepped) {
            ctx.rotate(Math.atan2(to.y - from.y, to.x - to.x));
          } else if (options.tension) {
            var toX = {
              x: to.x + shift.tx,
              y: to.y + shift.ty
            };
            var f = 0.1;
            ctx.rotate(Math.atan2(to.y - toX.y * (1 - f) - from.y * f, to.x - toX.x * (1 - f) - from.x * f));
          } else {
            ctx.rotate(Math.atan2(to.y - from.y, to.x - from.x));
          }

          ctx.translate(-offset, 0);
          ctx.beginPath();
          ctx.moveTo(0, 0);
          ctx.lineTo(-s, -s / 2);
          ctx.lineTo(-s * 0.9, 0);
          ctx.lineTo(-s, s / 2);
          ctx.closePath();
          ctx.fillStyle = ctx.strokeStyle;
          ctx.fill();
          ctx.restore();
        }

        ctx.restore(); // point helper
        // ctx.save();
        // ctx.strokeStyle = 'blue';
        // ctx.beginPath();
        // ctx.moveTo(from.x, from.y);
        // ctx.lineTo(from.x + shift.fx, from.y + shift.fy, 3, 3);
        // ctx.stroke();
        // ctx.strokeStyle = 'red';
        // ctx.beginPath();
        // ctx.moveTo(to.x, to.y);
        // ctx.lineTo(to.x + shift.tx, to.y + shift.ty, 3, 3);
        // ctx.stroke();
        // ctx.restore();
      }
    }]);

    return EdgeLine;
  }(chartjsEsmFacade.Line);
  EdgeLine.id = 'edgeLine';
  EdgeLine.defaults = /*#__PURE__*/Object.assign({}, chartjsEsmFacade.Line.defaults, {
    tension: 0,
    directed: false,
    arrowHeadSize: 15,
    arrowHeadOffset: 5
  });
  EdgeLine.defaultRoutes = chartjsEsmFacade.Line.defaultRoutes;

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) {
      arr2[i] = arr[i];
    }

    return arr2;
  }

  var arrayLikeToArray = _arrayLikeToArray;

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return arrayLikeToArray(arr);
  }

  var arrayWithoutHoles = _arrayWithoutHoles;

  function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
  }

  var iterableToArray = _iterableToArray;

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return arrayLikeToArray(o, minLen);
  }

  var unsupportedIterableToArray = _unsupportedIterableToArray;

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var nonIterableSpread = _nonIterableSpread;

  function _toConsumableArray(arr) {
    return arrayWithoutHoles(arr) || iterableToArray(arr) || unsupportedIterableToArray(arr) || nonIterableSpread();
  }

  var toConsumableArray = _toConsumableArray;

  function _superPropBase(object, property) {
    while (!Object.prototype.hasOwnProperty.call(object, property)) {
      object = getPrototypeOf(object);
      if (object === null) break;
    }

    return object;
  }

  var superPropBase = _superPropBase;

  var get = createCommonjsModule(function (module) {
    function _get(target, property, receiver) {
      if (typeof Reflect !== "undefined" && Reflect.get) {
        module.exports = _get = Reflect.get;
      } else {
        module.exports = _get = function _get(target, property, receiver) {
          var base = superPropBase(target, property);
          if (!base) return;
          var desc = Object.getOwnPropertyDescriptor(base, property);

          if (desc.get) {
            return desc.get.call(receiver);
          }

          return desc.value;
        };
      }

      return _get(target, property, receiver || target);
    }

    module.exports = _get;
  });

  /*!
   * Chart.js v3.0.0-alpha.2
   * https://www.chartjs.org
   * (c) 2020 Chart.js Contributors
   * Released under the MIT License
   */

  function _capitalize(str) {
    return str.charAt(0).toUpperCase() + str.slice(1);
  }

  /*!
   * Chart.js v3.0.0-alpha.2
   * https://www.chartjs.org
   * (c) 2020 Chart.js Contributors
   * Released under the MIT License
   */

  var arrayEvents = ['push', 'pop', 'shift', 'splice', 'unshift'];

  function listenArrayEvents(array, listener) {
    if (array._chartjs) {
      array._chartjs.listeners.push(listener);

      return;
    }

    Object.defineProperty(array, '_chartjs', {
      configurable: true,
      enumerable: false,
      value: {
        listeners: [listener]
      }
    });
    arrayEvents.forEach(function (key) {
      var method = '_onData' + _capitalize(key);

      var base = array[key];
      Object.defineProperty(array, key, {
        configurable: true,
        enumerable: false,
        value: function value() {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          var res = base.apply(this, args);

          array._chartjs.listeners.forEach(function (object) {
            if (typeof object[method] === 'function') {
              object[method].apply(object, args);
            }
          });

          return res;
        }
      });
    });
  }

  function unlistenArrayEvents(array, listener) {
    var stub = array._chartjs;

    if (!stub) {
      return;
    }

    var listeners = stub.listeners;
    var index = listeners.indexOf(listener);

    if (index !== -1) {
      listeners.splice(index, 1);
    }

    if (listeners.length > 0) {
      return;
    }

    arrayEvents.forEach(function (key) {
      delete array[key];
    });
    delete array._chartjs;
  }

  function interpolateNumber(from, to, factor) {
    if (from === to) {
      return to;
    }

    return from + (to - from) * factor;
  }

  function interpolatorPoint(fromArray, i, to, factor) {
    var from = fromArray[i] || fromArray[i - 1] || fromArray._source;

    if (!from) {
      return to;
    }

    var x = interpolateNumber(from.x, to.x, factor);
    var y = interpolateNumber(from.y, to.y, factor);
    var angle = Number.isNaN(from.angle) ? interpolateNumber(from.angle, to.angle, factor) : undefined;
    return {
      x: x,
      y: y,
      angle: angle
    };
  }

  function interpolatePoints(from, to, factor) {
    if (Array.isArray(from) && Array.isArray(to) && to.length > 0) {
      return to.map(function (t, i) {
        return interpolatorPoint(from, i, t, factor);
      });
    }

    return to;
  }

  function patchController(config, controller) {
    var elements = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
    var scales = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];
    chartjsEsmFacade.registry.addControllers(controller);
    chartjsEsmFacade.registry.addElements(elements);
    chartjsEsmFacade.registry.addScales(scales);
    config.type = controller.id;
    return config;
  }

  function _createSuper$1(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$1(); return function _createSuperInternal() { var Super = getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct$1() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
  var GraphController = /*#__PURE__*/function (_ScatterController) {
    inherits(GraphController, _ScatterController);

    var _super = _createSuper$1(GraphController);

    function GraphController(chart, datasetIndex) {
      var _this;

      classCallCheck(this, GraphController);

      _this = _super.call(this, chart, datasetIndex);
      _this._cachedEdgeOpts = {};
      _this._edgeListener = {
        _onDataPush: function _onDataPush() {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          var count = args.length;
          var start = _this.getDataset().edges.length - count;
          var parsed = _this._cachedMeta._parsedEdges;
          args.forEach(function (edge) {
            parsed.push(_this._parseDefinedEdge(edge));
          });

          _this._insertEdgeElements(start, count);
        },
        _onDataPop: function _onDataPop() {
          _this._cachedMeta.edges.pop();

          _this._cachedMeta._parsedEdges.pop();

          _this._scheduleResyncLayout();
        },
        _onDataShift: function _onDataShift() {
          _this._cachedMeta.edges.shift();

          _this._cachedMeta._parsedEdges.shift();

          _this._scheduleResyncLayout();
        },
        _onDataSplice: function _onDataSplice(start, count) {
          _this._cachedMeta.edges.splice(start, count);

          _this._cachedMeta._parsedEdges.splice(start, count);

          for (var _len2 = arguments.length, args = new Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
            args[_key2 - 2] = arguments[_key2];
          }

          if (args.length > 0) {
            var parsed = _this._cachedMeta._parsedEdges;
            parsed.splice.apply(parsed, [start, 0].concat(toConsumableArray(args.map(function (edge) {
              return _this._parseDefinedEdge(edge);
            }))));

            _this._insertEdgeElements(start, args.length);
          } else {
            _this._scheduleResyncLayout();
          }
        },
        _onDataUnshift: function _onDataUnshift() {
          var parsed = _this._cachedMeta._parsedEdges;

          for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
            args[_key3] = arguments[_key3];
          }

          parsed.unshift.apply(parsed, toConsumableArray(args.map(function (edge) {
            return _this._parseDefinedEdge(edge);
          })));

          _this._insertEdgeElements(0, args.length);
        }
      }; // this.resyncLayout();

      return _this;
    }

    createClass(GraphController, [{
      key: "initialize",
      value: function initialize() {
        var type = this._type;
        var defaultConfig = chartjsEsmFacade.defaults.get(type);
        this.edgeElementOptions = defaultConfig.edgeElementOptions;
        this.edgeElementType = chartjsEsmFacade.registry.getElement(defaultConfig.edgeElementType);

        get(getPrototypeOf(GraphController.prototype), "initialize", this).call(this);

        this._scheduleResyncLayout();
      }
    }, {
      key: "parse",
      value: function parse(start, count) {
        var meta = this._cachedMeta;
        var data = this._data;
        var iScale = meta.iScale;
        var vScale = meta.vScale;

        for (var i = 0; i < count; i++) {
          var index = i + start;
          var d = data[index];
          var v = meta._parsed[index] || {};

          if (d && typeof d.x === 'number') {
            v.x = d.x;
          }

          if (d && typeof d.y === 'number') {
            v.y = d.y;
          }

          meta._parsed[index] = v;
        }

        if (meta._parsed.length > data.length) {
          meta._parsed.splice(data.length, meta._parsed.length - data.length);
        }

        this._cachedMeta._sorted = false;
        iScale.invalidateCaches();
        vScale.invalidateCaches();

        this._parseEdges();
      }
    }, {
      key: "reset",
      value: function reset() {
        this.resetLayout();

        get(getPrototypeOf(GraphController.prototype), "reset", this).call(this);
      }
    }, {
      key: "update",
      value: function update(mode) {
        get(getPrototypeOf(GraphController.prototype), "update", this).call(this, mode);

        var meta = this._cachedMeta;
        var edges = meta.edges || [];
        this.updateEdgeElements(edges, 0, mode);
      }
    }, {
      key: "destroy",
      value: function destroy() {
        get(getPrototypeOf(GraphController.prototype), "destroy", this).call(this);

        if (this._edges) {
          unlistenArrayEvents(this._edges, this._edgeListener);
        }

        this.stopLayout();
      }
    }, {
      key: "updateEdgeElements",
      value: function updateEdgeElements(edges, start, mode) {
        var bak = {
          _cachedDataOpts: this._cachedDataOpts,
          dataElementType: this.dataElementType,
          dataElementOptions: this.dataElementOptions,
          _sharedOptions: this._sharedOptions
        };
        this._cachedDataOpts = {};
        this.dataElementType = this.edgeElementType;
        this.dataElementOptions = this.edgeElementOptions;
        var meta = this._cachedMeta;
        var nodes = meta.data;
        var data = meta._parsedEdges;
        var reset = mode === 'reset';
        var firstOpts = this.resolveDataElementOptions(start, mode);
        var sharedOptions = this.getSharedOptions(mode || 'normal', edges[start], firstOpts);
        var includeOptions = this.includeOptions(mode, sharedOptions);
        var xScale = meta.xScale;
        var yScale = meta.yScale;
        var base = {
          x: xScale.getBasePixel(),
          y: yScale.getBasePixel()
        };

        function copyPoint(point) {
          var x = reset ? base.x : xScale.getPixelForValue(point.x);
          var y = reset ? base.y : yScale.getPixelForValue(point.y);
          return {
            x: x,
            y: y,
            angle: point.angle
          };
        }

        for (var i = 0; i < edges.length; i++) {
          var edge = edges[i];
          var index = start + i;
          var parsed = data[index];
          var properties = {
            source: nodes[parsed.source],
            target: nodes[parsed.target],
            points: Array.isArray(parsed.points) ? parsed.points.map(copyPoint) : []
          };
          properties.points._source = nodes[parsed.source];

          if (includeOptions) {
            properties.options = this.resolveDataElementOptions(index, mode);
          }

          this.updateEdgeElement(edge, index, properties, mode);
        }

        this.updateSharedOptions(sharedOptions, mode);
        Object.assign(this, bak);
      }
    }, {
      key: "updateEdgeElement",
      value: function updateEdgeElement(edge, index, properties, mode) {
        get(getPrototypeOf(GraphController.prototype), "updateElement", this).call(this, edge, index, properties, mode);
      }
    }, {
      key: "updateElement",
      value: function updateElement(point, index, properties, mode) {
        if (mode === 'reset') {
          // start in center also in x
          var xScale = this._cachedMeta.xScale;
          properties.x = xScale.getBasePixel();
        }

        get(getPrototypeOf(GraphController.prototype), "updateElement", this).call(this, point, index, properties, mode);
      }
    }, {
      key: "resolveNodeIndex",
      value: function resolveNodeIndex(nodes, ref) {
        if (typeof ref === 'number') {
          // index
          return ref;
        }

        if (typeof ref === 'string') {
          // label
          var labels = this.chart.data.labels;
          return labels.indexOf(ref);
        }

        var nIndex = nodes.indexOf(ref);

        if (nIndex >= 0) {
          // hit
          return nIndex;
        }

        if (ref && typeof ref.index === 'number') {
          return ref.index;
        }

        var data = this.getDataset().data;
        var index = data.indexOf(ref);

        if (index >= 0) {
          return index;
        }

        console.warn('cannot resolve edge ref', ref);
        return -1;
      }
    }, {
      key: "buildOrUpdateElements",
      value: function buildOrUpdateElements() {
        var dataset = this.getDataset();
        var edges = dataset.edges || []; // In order to correctly handle data addition/deletion animation (an thus simulate
        // real-time charts), we need to monitor these data modifications and synchronize
        // the internal meta data accordingly.

        if (this._edges !== edges) {
          if (this._edges) {
            // This case happens when the user replaced the data array instance.
            unlistenArrayEvents(this._edges, this._edgeListener);
          }

          if (edges && Object.isExtensible(edges)) {
            listenArrayEvents(edges, this._edgeListener);
          }

          this._edges = edges;
        }

        get(getPrototypeOf(GraphController.prototype), "buildOrUpdateElements", this).call(this);
      }
    }, {
      key: "draw",
      value: function draw() {
        var meta = this._cachedMeta;
        var edges = meta.edges || [];
        var elements = meta.data || [];
        var area = this.chart.chartArea;
        var ctx = this._ctx;

        if (edges.length > 0) {
          chartjsEsmFacade.clipArea(ctx, area);
          edges.forEach(function (edge) {
            return edge.draw(ctx, area);
          });
          chartjsEsmFacade.unclipArea(ctx);
        }

        elements.forEach(function (elem) {
          return elem.draw(ctx, area);
        });
      }
    }, {
      key: "_resyncElements",
      value: function _resyncElements() {
        get(getPrototypeOf(GraphController.prototype), "_resyncElements", this).call(this);

        var meta = this._cachedMeta;
        var edges = meta._parsedEdges;
        var metaEdges = meta.edges || (meta.edges = []);
        var numMeta = metaEdges.length;
        var numData = edges.length;

        if (numData < numMeta) {
          metaEdges.splice(numData, numMeta - numData);

          this._scheduleResyncLayout();
        } else if (numData > numMeta) {
          this._insertEdgeElements(numMeta, numData - numMeta);
        }
      }
    }, {
      key: "getTreeRootIndex",
      value: function getTreeRootIndex() {
        var ds = this.getDataset();
        var nodes = ds.data;

        if (ds.derivedEdges) {
          // find the one with no parent
          return nodes.findIndex(function (d) {
            return d.parent == null;
          });
        } // find the one with no edge


        var edges = this._cachedMeta._parsedEdges || [];
        var nodeIndices = new Set(nodes.map(function (_, i) {
          return i;
        }));
        edges.forEach(function (edge) {
          nodeIndices["delete"](edge.targetIndex);
        });
        return Array.from(nodeIndices)[0];
      }
    }, {
      key: "getTreeRoot",
      value: function getTreeRoot() {
        var index = this.getTreeRootIndex();
        var p = this.getParsed(index);
        p.index = index;
        return p;
      }
    }, {
      key: "getTreeChildren",
      value: function getTreeChildren(node) {
        var _this2 = this;

        var edges = this._cachedMeta._parsedEdges;
        return edges.filter(function (d) {
          return d.source === node.index;
        }).map(function (d) {
          var p = _this2.getParsed(d.target);

          p.index = d.target;
          return p;
        });
      }
    }, {
      key: "_parseDefinedEdge",
      value: function _parseDefinedEdge(edge) {
        var ds = this.getDataset();
        var data = ds.data;
        return {
          source: this.resolveNodeIndex(data, edge.source),
          target: this.resolveNodeIndex(data, edge.target),
          points: []
        };
      }
    }, {
      key: "_parseEdges",
      value: function _parseEdges() {
        var _this3 = this;

        var ds = this.getDataset();
        var data = ds.data;
        var meta = this._cachedMeta;

        if (ds.edges) {
          return meta._parsedEdges = ds.edges.map(function (edge) {
            return _this3._parseDefinedEdge(edge);
          });
        }

        var edges = meta._parsedEdges = []; // try to derive edges via parent links

        data.forEach(function (node, i) {
          if (node.parent != null) {
            // tree edge
            var parent = _this3.resolveNodeIndex(data, node.parent);

            edges.push({
              source: parent,
              target: i,
              points: []
            });
          }
        });
        return edges;
      }
    }, {
      key: "addElements",
      value: function addElements() {
        get(getPrototypeOf(GraphController.prototype), "addElements", this).call(this);

        var meta = this._cachedMeta;

        var edges = this._parseEdges();

        var metaData = meta.edges = new Array(edges.length);

        for (var i = 0; i < edges.length; ++i) {
          metaData[i] = new this.edgeElementType();
        }
      }
    }, {
      key: "_resyncEdgeElements",
      value: function _resyncEdgeElements() {
        var meta = this._cachedMeta;

        var edges = this._parseEdges();

        var metaData = meta.edges || (meta.edges = []);

        for (var i = 0; i < edges.length; ++i) {
          metaData[i] = metaData[i] || new this.edgeElementType();
        }

        if (edges.length < metaData.length) {
          metaData.splice(edges.length, metaData.length);
        }
      }
    }, {
      key: "_insertElements",
      value: function _insertElements(start, count) {
        get(getPrototypeOf(GraphController.prototype), "_insertElements", this).call(this, start, count);

        if (count > 0) {
          this._resyncEdgeElements();
        }
      }
    }, {
      key: "_removeElements",
      value: function _removeElements(start, count) {
        get(getPrototypeOf(GraphController.prototype), "_removeElements", this).call(this, start, count);

        if (count > 0) {
          this._resyncEdgeElements();
        }
      }
    }, {
      key: "_insertEdgeElements",
      value: function _insertEdgeElements(start, count) {
        var _this$_cachedMeta$edg;

        var elements = [];

        for (var i = 0; i < count; i++) {
          elements.push(new this.edgeElementType());
        }

        (_this$_cachedMeta$edg = this._cachedMeta.edges).splice.apply(_this$_cachedMeta$edg, [start, 0].concat(elements));

        this.updateEdgeElements(elements, start, 'reset');

        this._scheduleResyncLayout();
      }
    }, {
      key: "_onDataPush",
      value: function _onDataPush() {
        get(getPrototypeOf(GraphController.prototype), "_onDataPush", this).apply(this, Array.from(arguments));

        this._scheduleResyncLayout();
      }
    }, {
      key: "_onDataPop",
      value: function _onDataPop() {
        get(getPrototypeOf(GraphController.prototype), "_onDataPop", this).call(this);

        this._scheduleResyncLayout();
      }
    }, {
      key: "_onDataShift",
      value: function _onDataShift() {
        get(getPrototypeOf(GraphController.prototype), "_onDataShift", this).call(this);

        this._scheduleResyncLayout();
      }
    }, {
      key: "_onDataSplice",
      value: function _onDataSplice() {
        get(getPrototypeOf(GraphController.prototype), "_onDataSplice", this).apply(this, Array.from(arguments));

        this._scheduleResyncLayout();
      }
    }, {
      key: "_onDataUnshift",
      value: function _onDataUnshift() {
        get(getPrototypeOf(GraphController.prototype), "_onDataUnshift", this).apply(this, Array.from(arguments));

        this._scheduleResyncLayout();
      }
    }, {
      key: "reLayout",
      value: function reLayout() {// hook
      }
    }, {
      key: "resetLayout",
      value: function resetLayout() {// hook
      }
    }, {
      key: "stopLayout",
      value: function stopLayout() {// hook
      }
    }, {
      key: "_scheduleResyncLayout",
      value: function _scheduleResyncLayout() {
        var _this4 = this;

        if (this._scheduleResyncLayoutId != null) {
          return;
        }

        this._scheduleResyncLayoutId = chartjsEsmFacade.requestAnimFrame.call(window, function () {
          _this4._scheduleResyncLayoutId = null;

          _this4.resyncLayout();
        });
      }
    }, {
      key: "resyncLayout",
      value: function resyncLayout() {// hook
      }
    }]);

    return GraphController;
  }(chartjsEsmFacade.ScatterController);
  GraphController.id = 'graph';
  GraphController.defaults = /*#__PURE__*/chartjsEsmFacade.merge({}, [chartjsEsmFacade.ScatterController.defaults, {
    datasets: {
      clip: 10,
      // some space in combination with padding
      animation: {
        points: {
          fn: interpolatePoints,
          properties: ['points']
        }
      }
    },
    layout: {
      padding: 10
    },
    scales: {
      x: {
        display: false,
        ticks: {
          maxTicksLimit: 2,
          precision: 100,
          minRotation: 0,
          maxRotation: 0
        }
      },
      y: {
        display: false,
        ticks: {
          maxTicksLimit: 2,
          precision: 100,
          minRotation: 0,
          maxRotation: 0
        }
      }
    },
    tooltips: {
      callbacks: {
        label: function label(item) {
          return item.chart.data.labels[item.dataIndex];
        }
      }
    },
    edgeElementType: EdgeLine.id,
    edgeElementOptions: Object.assign({
      tension: 'lineTension',
      stepped: 'lineStepped',
      directed: 'directed',
      arrowHeadSize: 'arrowHeadSize',
      arrowHeadOffset: 'pointRadius'
    }, function () {
      var options = {};
      chartjsEsmFacade.LineController.defaults.datasetElementOptions.forEach(function (attr) {
        options[attr] = "line".concat(attr[0].toUpperCase()).concat(attr.slice(1));
      });
      return options;
    }())
  }]);
  var GraphChart = /*#__PURE__*/function (_Chart) {
    inherits(GraphChart, _Chart);

    var _super2 = _createSuper$1(GraphChart);

    function GraphChart(item, config) {
      classCallCheck(this, GraphChart);

      return _super2.call(this, item, patchController(config, GraphController, [EdgeLine, chartjsEsmFacade.Point], chartjsEsmFacade.LinearScale));
    }

    return GraphChart;
  }(chartjsEsmFacade.Chart);
  GraphChart.id = GraphController.id;

  function forceCenter (x, y) {
    var nodes;
    if (x == null) x = 0;
    if (y == null) y = 0;

    function force() {
      var i,
          n = nodes.length,
          node,
          sx = 0,
          sy = 0;

      for (i = 0; i < n; ++i) {
        node = nodes[i], sx += node.x, sy += node.y;
      }

      for (sx = sx / n - x, sy = sy / n - y, i = 0; i < n; ++i) {
        node = nodes[i], node.x -= sx, node.y -= sy;
      }
    }

    force.initialize = function (_) {
      nodes = _;
    };

    force.x = function (_) {
      return arguments.length ? (x = +_, force) : x;
    };

    force.y = function (_) {
      return arguments.length ? (y = +_, force) : y;
    };

    return force;
  }

  function tree_add (d) {
    var x = +this._x.call(null, d),
        y = +this._y.call(null, d);
    return add(this.cover(x, y), x, y, d);
  }

  function add(tree, x, y, d) {
    if (isNaN(x) || isNaN(y)) return tree; // ignore invalid points

    var parent,
        node = tree._root,
        leaf = {
      data: d
    },
        x0 = tree._x0,
        y0 = tree._y0,
        x1 = tree._x1,
        y1 = tree._y1,
        xm,
        ym,
        xp,
        yp,
        right,
        bottom,
        i,
        j; // If the tree is empty, initialize the root as a leaf.

    if (!node) return tree._root = leaf, tree; // Find the existing leaf for the new point, or add it.

    while (node.length) {
      if (right = x >= (xm = (x0 + x1) / 2)) x0 = xm;else x1 = xm;
      if (bottom = y >= (ym = (y0 + y1) / 2)) y0 = ym;else y1 = ym;
      if (parent = node, !(node = node[i = bottom << 1 | right])) return parent[i] = leaf, tree;
    } // Is the new point is exactly coincident with the existing point?


    xp = +tree._x.call(null, node.data);
    yp = +tree._y.call(null, node.data);
    if (x === xp && y === yp) return leaf.next = node, parent ? parent[i] = leaf : tree._root = leaf, tree; // Otherwise, split the leaf node until the old and new point are separated.

    do {
      parent = parent ? parent[i] = new Array(4) : tree._root = new Array(4);
      if (right = x >= (xm = (x0 + x1) / 2)) x0 = xm;else x1 = xm;
      if (bottom = y >= (ym = (y0 + y1) / 2)) y0 = ym;else y1 = ym;
    } while ((i = bottom << 1 | right) === (j = (yp >= ym) << 1 | xp >= xm));

    return parent[j] = node, parent[i] = leaf, tree;
  }

  function addAll(data) {
    var d,
        i,
        n = data.length,
        x,
        y,
        xz = new Array(n),
        yz = new Array(n),
        x0 = Infinity,
        y0 = Infinity,
        x1 = -Infinity,
        y1 = -Infinity; // Compute the points and their extent.

    for (i = 0; i < n; ++i) {
      if (isNaN(x = +this._x.call(null, d = data[i])) || isNaN(y = +this._y.call(null, d))) continue;
      xz[i] = x;
      yz[i] = y;
      if (x < x0) x0 = x;
      if (x > x1) x1 = x;
      if (y < y0) y0 = y;
      if (y > y1) y1 = y;
    } // If there were no (valid) points, abort.


    if (x0 > x1 || y0 > y1) return this; // Expand the tree to cover the new points.

    this.cover(x0, y0).cover(x1, y1); // Add the new points.

    for (i = 0; i < n; ++i) {
      add(this, xz[i], yz[i], data[i]);
    }

    return this;
  }

  function tree_cover (x, y) {
    if (isNaN(x = +x) || isNaN(y = +y)) return this; // ignore invalid points

    var x0 = this._x0,
        y0 = this._y0,
        x1 = this._x1,
        y1 = this._y1; // If the quadtree has no extent, initialize them.
    // Integer extent are necessary so that if we later double the extent,
    // the existing quadrant boundaries don’t change due to floating point error!

    if (isNaN(x0)) {
      x1 = (x0 = Math.floor(x)) + 1;
      y1 = (y0 = Math.floor(y)) + 1;
    } // Otherwise, double repeatedly to cover.
    else {
        var z = x1 - x0,
            node = this._root,
            parent,
            i;

        while (x0 > x || x >= x1 || y0 > y || y >= y1) {
          i = (y < y0) << 1 | x < x0;
          parent = new Array(4), parent[i] = node, node = parent, z *= 2;

          switch (i) {
            case 0:
              x1 = x0 + z, y1 = y0 + z;
              break;

            case 1:
              x0 = x1 - z, y1 = y0 + z;
              break;

            case 2:
              x1 = x0 + z, y0 = y1 - z;
              break;

            case 3:
              x0 = x1 - z, y0 = y1 - z;
              break;
          }
        }

        if (this._root && this._root.length) this._root = node;
      }

    this._x0 = x0;
    this._y0 = y0;
    this._x1 = x1;
    this._y1 = y1;
    return this;
  }

  function tree_data () {
    var data = [];
    this.visit(function (node) {
      if (!node.length) do {
        data.push(node.data);
      } while (node = node.next);
    });
    return data;
  }

  function tree_extent (_) {
    return arguments.length ? this.cover(+_[0][0], +_[0][1]).cover(+_[1][0], +_[1][1]) : isNaN(this._x0) ? undefined : [[this._x0, this._y0], [this._x1, this._y1]];
  }

  function Quad (node, x0, y0, x1, y1) {
    this.node = node;
    this.x0 = x0;
    this.y0 = y0;
    this.x1 = x1;
    this.y1 = y1;
  }

  function tree_find (x, y, radius) {
    var data,
        x0 = this._x0,
        y0 = this._y0,
        x1,
        y1,
        x2,
        y2,
        x3 = this._x1,
        y3 = this._y1,
        quads = [],
        node = this._root,
        q,
        i;
    if (node) quads.push(new Quad(node, x0, y0, x3, y3));
    if (radius == null) radius = Infinity;else {
      x0 = x - radius, y0 = y - radius;
      x3 = x + radius, y3 = y + radius;
      radius *= radius;
    }

    while (q = quads.pop()) {
      // Stop searching if this quadrant can’t contain a closer node.
      if (!(node = q.node) || (x1 = q.x0) > x3 || (y1 = q.y0) > y3 || (x2 = q.x1) < x0 || (y2 = q.y1) < y0) continue; // Bisect the current quadrant.

      if (node.length) {
        var xm = (x1 + x2) / 2,
            ym = (y1 + y2) / 2;
        quads.push(new Quad(node[3], xm, ym, x2, y2), new Quad(node[2], x1, ym, xm, y2), new Quad(node[1], xm, y1, x2, ym), new Quad(node[0], x1, y1, xm, ym)); // Visit the closest quadrant first.

        if (i = (y >= ym) << 1 | x >= xm) {
          q = quads[quads.length - 1];
          quads[quads.length - 1] = quads[quads.length - 1 - i];
          quads[quads.length - 1 - i] = q;
        }
      } // Visit this point. (Visiting coincident points isn’t necessary!)
      else {
          var dx = x - +this._x.call(null, node.data),
              dy = y - +this._y.call(null, node.data),
              d2 = dx * dx + dy * dy;

          if (d2 < radius) {
            var d = Math.sqrt(radius = d2);
            x0 = x - d, y0 = y - d;
            x3 = x + d, y3 = y + d;
            data = node.data;
          }
        }
    }

    return data;
  }

  function tree_remove (d) {
    if (isNaN(x = +this._x.call(null, d)) || isNaN(y = +this._y.call(null, d))) return this; // ignore invalid points

    var parent,
        node = this._root,
        retainer,
        previous,
        next,
        x0 = this._x0,
        y0 = this._y0,
        x1 = this._x1,
        y1 = this._y1,
        x,
        y,
        xm,
        ym,
        right,
        bottom,
        i,
        j; // If the tree is empty, initialize the root as a leaf.

    if (!node) return this; // Find the leaf node for the point.
    // While descending, also retain the deepest parent with a non-removed sibling.

    if (node.length) while (true) {
      if (right = x >= (xm = (x0 + x1) / 2)) x0 = xm;else x1 = xm;
      if (bottom = y >= (ym = (y0 + y1) / 2)) y0 = ym;else y1 = ym;
      if (!(parent = node, node = node[i = bottom << 1 | right])) return this;
      if (!node.length) break;
      if (parent[i + 1 & 3] || parent[i + 2 & 3] || parent[i + 3 & 3]) retainer = parent, j = i;
    } // Find the point to remove.

    while (node.data !== d) {
      if (!(previous = node, node = node.next)) return this;
    }

    if (next = node.next) delete node.next; // If there are multiple coincident points, remove just the point.

    if (previous) return next ? previous.next = next : delete previous.next, this; // If this is the root point, remove it.

    if (!parent) return this._root = next, this; // Remove this leaf.

    next ? parent[i] = next : delete parent[i]; // If the parent now contains exactly one leaf, collapse superfluous parents.

    if ((node = parent[0] || parent[1] || parent[2] || parent[3]) && node === (parent[3] || parent[2] || parent[1] || parent[0]) && !node.length) {
      if (retainer) retainer[j] = node;else this._root = node;
    }

    return this;
  }
  function removeAll(data) {
    for (var i = 0, n = data.length; i < n; ++i) {
      this.remove(data[i]);
    }

    return this;
  }

  function tree_root () {
    return this._root;
  }

  function tree_size () {
    var size = 0;
    this.visit(function (node) {
      if (!node.length) do {
        ++size;
      } while (node = node.next);
    });
    return size;
  }

  function tree_visit (callback) {
    var quads = [],
        q,
        node = this._root,
        child,
        x0,
        y0,
        x1,
        y1;
    if (node) quads.push(new Quad(node, this._x0, this._y0, this._x1, this._y1));

    while (q = quads.pop()) {
      if (!callback(node = q.node, x0 = q.x0, y0 = q.y0, x1 = q.x1, y1 = q.y1) && node.length) {
        var xm = (x0 + x1) / 2,
            ym = (y0 + y1) / 2;
        if (child = node[3]) quads.push(new Quad(child, xm, ym, x1, y1));
        if (child = node[2]) quads.push(new Quad(child, x0, ym, xm, y1));
        if (child = node[1]) quads.push(new Quad(child, xm, y0, x1, ym));
        if (child = node[0]) quads.push(new Quad(child, x0, y0, xm, ym));
      }
    }

    return this;
  }

  function tree_visitAfter (callback) {
    var quads = [],
        next = [],
        q;
    if (this._root) quads.push(new Quad(this._root, this._x0, this._y0, this._x1, this._y1));

    while (q = quads.pop()) {
      var node = q.node;

      if (node.length) {
        var child,
            x0 = q.x0,
            y0 = q.y0,
            x1 = q.x1,
            y1 = q.y1,
            xm = (x0 + x1) / 2,
            ym = (y0 + y1) / 2;
        if (child = node[0]) quads.push(new Quad(child, x0, y0, xm, ym));
        if (child = node[1]) quads.push(new Quad(child, xm, y0, x1, ym));
        if (child = node[2]) quads.push(new Quad(child, x0, ym, xm, y1));
        if (child = node[3]) quads.push(new Quad(child, xm, ym, x1, y1));
      }

      next.push(q);
    }

    while (q = next.pop()) {
      callback(q.node, q.x0, q.y0, q.x1, q.y1);
    }

    return this;
  }

  function defaultX(d) {
    return d[0];
  }
  function tree_x (_) {
    return arguments.length ? (this._x = _, this) : this._x;
  }

  function defaultY(d) {
    return d[1];
  }
  function tree_y (_) {
    return arguments.length ? (this._y = _, this) : this._y;
  }

  function quadtree(nodes, x, y) {
    var tree = new Quadtree(x == null ? defaultX : x, y == null ? defaultY : y, NaN, NaN, NaN, NaN);
    return nodes == null ? tree : tree.addAll(nodes);
  }

  function Quadtree(x, y, x0, y0, x1, y1) {
    this._x = x;
    this._y = y;
    this._x0 = x0;
    this._y0 = y0;
    this._x1 = x1;
    this._y1 = y1;
    this._root = undefined;
  }

  function leaf_copy(leaf) {
    var copy = {
      data: leaf.data
    },
        next = copy;

    while (leaf = leaf.next) {
      next = next.next = {
        data: leaf.data
      };
    }

    return copy;
  }

  var treeProto = quadtree.prototype = Quadtree.prototype;

  treeProto.copy = function () {
    var copy = new Quadtree(this._x, this._y, this._x0, this._y0, this._x1, this._y1),
        node = this._root,
        nodes,
        child;
    if (!node) return copy;
    if (!node.length) return copy._root = leaf_copy(node), copy;
    nodes = [{
      source: node,
      target: copy._root = new Array(4)
    }];

    while (node = nodes.pop()) {
      for (var i = 0; i < 4; ++i) {
        if (child = node.source[i]) {
          if (child.length) nodes.push({
            source: child,
            target: node.target[i] = new Array(4)
          });else node.target[i] = leaf_copy(child);
        }
      }
    }

    return copy;
  };

  treeProto.add = tree_add;
  treeProto.addAll = addAll;
  treeProto.cover = tree_cover;
  treeProto.data = tree_data;
  treeProto.extent = tree_extent;
  treeProto.find = tree_find;
  treeProto.remove = tree_remove;
  treeProto.removeAll = removeAll;
  treeProto.root = tree_root;
  treeProto.size = tree_size;
  treeProto.visit = tree_visit;
  treeProto.visitAfter = tree_visitAfter;
  treeProto.x = tree_x;
  treeProto.y = tree_y;

  function constant (x) {
    return function () {
      return x;
    };
  }

  function jiggle () {
    return (Math.random() - 0.5) * 1e-6;
  }

  function x(d) {
    return d.x + d.vx;
  }

  function y(d) {
    return d.y + d.vy;
  }

  function forceCollide (radius) {
    var nodes,
        radii,
        strength = 1,
        iterations = 1;
    if (typeof radius !== "function") radius = constant(radius == null ? 1 : +radius);

    function force() {
      var i,
          n = nodes.length,
          tree,
          node,
          xi,
          yi,
          ri,
          ri2;

      for (var k = 0; k < iterations; ++k) {
        tree = quadtree(nodes, x, y).visitAfter(prepare);

        for (i = 0; i < n; ++i) {
          node = nodes[i];
          ri = radii[node.index], ri2 = ri * ri;
          xi = node.x + node.vx;
          yi = node.y + node.vy;
          tree.visit(apply);
        }
      }

      function apply(quad, x0, y0, x1, y1) {
        var data = quad.data,
            rj = quad.r,
            r = ri + rj;

        if (data) {
          if (data.index > node.index) {
            var x = xi - data.x - data.vx,
                y = yi - data.y - data.vy,
                l = x * x + y * y;

            if (l < r * r) {
              if (x === 0) x = jiggle(), l += x * x;
              if (y === 0) y = jiggle(), l += y * y;
              l = (r - (l = Math.sqrt(l))) / l * strength;
              node.vx += (x *= l) * (r = (rj *= rj) / (ri2 + rj));
              node.vy += (y *= l) * r;
              data.vx -= x * (r = 1 - r);
              data.vy -= y * r;
            }
          }

          return;
        }

        return x0 > xi + r || x1 < xi - r || y0 > yi + r || y1 < yi - r;
      }
    }

    function prepare(quad) {
      if (quad.data) return quad.r = radii[quad.data.index];

      for (var i = quad.r = 0; i < 4; ++i) {
        if (quad[i] && quad[i].r > quad.r) {
          quad.r = quad[i].r;
        }
      }
    }

    function initialize() {
      if (!nodes) return;
      var i,
          n = nodes.length,
          node;
      radii = new Array(n);

      for (i = 0; i < n; ++i) {
        node = nodes[i], radii[node.index] = +radius(node, i, nodes);
      }
    }

    force.initialize = function (_) {
      nodes = _;
      initialize();
    };

    force.iterations = function (_) {
      return arguments.length ? (iterations = +_, force) : iterations;
    };

    force.strength = function (_) {
      return arguments.length ? (strength = +_, force) : strength;
    };

    force.radius = function (_) {
      return arguments.length ? (radius = typeof _ === "function" ? _ : constant(+_), initialize(), force) : radius;
    };

    return force;
  }

  function index(d) {
    return d.index;
  }

  function find(nodeById, nodeId) {
    var node = nodeById.get(nodeId);
    if (!node) throw new Error("missing: " + nodeId);
    return node;
  }

  function forceLink (links) {
    var id = index,
        strength = defaultStrength,
        strengths,
        distance = constant(30),
        distances,
        nodes,
        count,
        bias,
        iterations = 1;
    if (links == null) links = [];

    function defaultStrength(link) {
      return 1 / Math.min(count[link.source.index], count[link.target.index]);
    }

    function force(alpha) {
      for (var k = 0, n = links.length; k < iterations; ++k) {
        for (var i = 0, link, source, target, x, y, l, b; i < n; ++i) {
          link = links[i], source = link.source, target = link.target;
          x = target.x + target.vx - source.x - source.vx || jiggle();
          y = target.y + target.vy - source.y - source.vy || jiggle();
          l = Math.sqrt(x * x + y * y);
          l = (l - distances[i]) / l * alpha * strengths[i];
          x *= l, y *= l;
          target.vx -= x * (b = bias[i]);
          target.vy -= y * b;
          source.vx += x * (b = 1 - b);
          source.vy += y * b;
        }
      }
    }

    function initialize() {
      if (!nodes) return;
      var i,
          n = nodes.length,
          m = links.length,
          nodeById = new Map(nodes.map(function (d, i) {
        return [id(d, i, nodes), d];
      })),
          link;

      for (i = 0, count = new Array(n); i < m; ++i) {
        link = links[i], link.index = i;
        if (_typeof_1(link.source) !== "object") link.source = find(nodeById, link.source);
        if (_typeof_1(link.target) !== "object") link.target = find(nodeById, link.target);
        count[link.source.index] = (count[link.source.index] || 0) + 1;
        count[link.target.index] = (count[link.target.index] || 0) + 1;
      }

      for (i = 0, bias = new Array(m); i < m; ++i) {
        link = links[i], bias[i] = count[link.source.index] / (count[link.source.index] + count[link.target.index]);
      }

      strengths = new Array(m), initializeStrength();
      distances = new Array(m), initializeDistance();
    }

    function initializeStrength() {
      if (!nodes) return;

      for (var i = 0, n = links.length; i < n; ++i) {
        strengths[i] = +strength(links[i], i, links);
      }
    }

    function initializeDistance() {
      if (!nodes) return;

      for (var i = 0, n = links.length; i < n; ++i) {
        distances[i] = +distance(links[i], i, links);
      }
    }

    force.initialize = function (_) {
      nodes = _;
      initialize();
    };

    force.links = function (_) {
      return arguments.length ? (links = _, initialize(), force) : links;
    };

    force.id = function (_) {
      return arguments.length ? (id = _, force) : id;
    };

    force.iterations = function (_) {
      return arguments.length ? (iterations = +_, force) : iterations;
    };

    force.strength = function (_) {
      return arguments.length ? (strength = typeof _ === "function" ? _ : constant(+_), initializeStrength(), force) : strength;
    };

    force.distance = function (_) {
      return arguments.length ? (distance = typeof _ === "function" ? _ : constant(+_), initializeDistance(), force) : distance;
    };

    return force;
  }

  var noop = {
    value: function value() {}
  };

  function dispatch() {
    for (var i = 0, n = arguments.length, _ = {}, t; i < n; ++i) {
      if (!(t = arguments[i] + "") || t in _ || /[\s.]/.test(t)) throw new Error("illegal type: " + t);
      _[t] = [];
    }

    return new Dispatch(_);
  }

  function Dispatch(_) {
    this._ = _;
  }

  function parseTypenames(typenames, types) {
    return typenames.trim().split(/^|\s+/).map(function (t) {
      var name = "",
          i = t.indexOf(".");
      if (i >= 0) name = t.slice(i + 1), t = t.slice(0, i);
      if (t && !types.hasOwnProperty(t)) throw new Error("unknown type: " + t);
      return {
        type: t,
        name: name
      };
    });
  }

  Dispatch.prototype = dispatch.prototype = {
    constructor: Dispatch,
    on: function on(typename, callback) {
      var _ = this._,
          T = parseTypenames(typename + "", _),
          t,
          i = -1,
          n = T.length; // If no callback was specified, return the callback of the given type and name.

      if (arguments.length < 2) {
        while (++i < n) {
          if ((t = (typename = T[i]).type) && (t = get$1(_[t], typename.name))) return t;
        }

        return;
      } // If a type was specified, set the callback for the given type and name.
      // Otherwise, if a null callback was specified, remove callbacks of the given name.


      if (callback != null && typeof callback !== "function") throw new Error("invalid callback: " + callback);

      while (++i < n) {
        if (t = (typename = T[i]).type) _[t] = set(_[t], typename.name, callback);else if (callback == null) for (t in _) {
          _[t] = set(_[t], typename.name, null);
        }
      }

      return this;
    },
    copy: function copy() {
      var copy = {},
          _ = this._;

      for (var t in _) {
        copy[t] = _[t].slice();
      }

      return new Dispatch(copy);
    },
    call: function call(type, that) {
      if ((n = arguments.length - 2) > 0) for (var args = new Array(n), i = 0, n, t; i < n; ++i) {
        args[i] = arguments[i + 2];
      }
      if (!this._.hasOwnProperty(type)) throw new Error("unknown type: " + type);

      for (t = this._[type], i = 0, n = t.length; i < n; ++i) {
        t[i].value.apply(that, args);
      }
    },
    apply: function apply(type, that, args) {
      if (!this._.hasOwnProperty(type)) throw new Error("unknown type: " + type);

      for (var t = this._[type], i = 0, n = t.length; i < n; ++i) {
        t[i].value.apply(that, args);
      }
    }
  };

  function get$1(type, name) {
    for (var i = 0, n = type.length, c; i < n; ++i) {
      if ((c = type[i]).name === name) {
        return c.value;
      }
    }
  }

  function set(type, name, callback) {
    for (var i = 0, n = type.length; i < n; ++i) {
      if (type[i].name === name) {
        type[i] = noop, type = type.slice(0, i).concat(type.slice(i + 1));
        break;
      }
    }

    if (callback != null) type.push({
      name: name,
      value: callback
    });
    return type;
  }

  var frame = 0,
      // is an animation frame pending?
  timeout = 0,
      // is a timeout pending?
  interval = 0,
      // are any timers active?
  pokeDelay = 1000,
      // how frequently we check for clock skew
  taskHead,
      taskTail,
      clockLast = 0,
      clockNow = 0,
      clockSkew = 0,
      clock = (typeof performance === "undefined" ? "undefined" : _typeof_1(performance)) === "object" && performance.now ? performance : Date,
      setFrame = (typeof window === "undefined" ? "undefined" : _typeof_1(window)) === "object" && window.requestAnimationFrame ? window.requestAnimationFrame.bind(window) : function (f) {
    setTimeout(f, 17);
  };
  function now() {
    return clockNow || (setFrame(clearNow), clockNow = clock.now() + clockSkew);
  }

  function clearNow() {
    clockNow = 0;
  }

  function Timer() {
    this._call = this._time = this._next = null;
  }
  Timer.prototype = timer.prototype = {
    constructor: Timer,
    restart: function restart(callback, delay, time) {
      if (typeof callback !== "function") throw new TypeError("callback is not a function");
      time = (time == null ? now() : +time) + (delay == null ? 0 : +delay);

      if (!this._next && taskTail !== this) {
        if (taskTail) taskTail._next = this;else taskHead = this;
        taskTail = this;
      }

      this._call = callback;
      this._time = time;
      sleep();
    },
    stop: function stop() {
      if (this._call) {
        this._call = null;
        this._time = Infinity;
        sleep();
      }
    }
  };
  function timer(callback, delay, time) {
    var t = new Timer();
    t.restart(callback, delay, time);
    return t;
  }
  function timerFlush() {
    now(); // Get the current time, if not already set.

    ++frame; // Pretend we’ve set an alarm, if we haven’t already.

    var t = taskHead,
        e;

    while (t) {
      if ((e = clockNow - t._time) >= 0) t._call.call(null, e);
      t = t._next;
    }

    --frame;
  }

  function wake() {
    clockNow = (clockLast = clock.now()) + clockSkew;
    frame = timeout = 0;

    try {
      timerFlush();
    } finally {
      frame = 0;
      nap();
      clockNow = 0;
    }
  }

  function poke() {
    var now = clock.now(),
        delay = now - clockLast;
    if (delay > pokeDelay) clockSkew -= delay, clockLast = now;
  }

  function nap() {
    var t0,
        t1 = taskHead,
        t2,
        time = Infinity;

    while (t1) {
      if (t1._call) {
        if (time > t1._time) time = t1._time;
        t0 = t1, t1 = t1._next;
      } else {
        t2 = t1._next, t1._next = null;
        t1 = t0 ? t0._next = t2 : taskHead = t2;
      }
    }

    taskTail = t0;
    sleep(time);
  }

  function sleep(time) {
    if (frame) return; // Soonest alarm already set, or will be.

    if (timeout) timeout = clearTimeout(timeout);
    var delay = time - clockNow; // Strictly less than if we recomputed clockNow.

    if (delay > 24) {
      if (time < Infinity) timeout = setTimeout(wake, time - clock.now() - clockSkew);
      if (interval) interval = clearInterval(interval);
    } else {
      if (!interval) clockLast = clock.now(), interval = setInterval(poke, pokeDelay);
      frame = 1, setFrame(wake);
    }
  }

  function x$1(d) {
    return d.x;
  }
  function y$1(d) {
    return d.y;
  }
  var initialRadius = 10,
      initialAngle = Math.PI * (3 - Math.sqrt(5));
  function forceSimulation (_nodes) {
    var simulation,
        _alpha = 1,
        _alphaMin = 0.001,
        _alphaDecay = 1 - Math.pow(_alphaMin, 1 / 300),
        _alphaTarget = 0,
        _velocityDecay = 0.6,
        forces = new Map(),
        stepper = timer(step),
        event = dispatch("tick", "end");

    if (_nodes == null) _nodes = [];

    function step() {
      tick();
      event.call("tick", simulation);

      if (_alpha < _alphaMin) {
        stepper.stop();
        event.call("end", simulation);
      }
    }

    function tick(iterations) {
      var i,
          n = _nodes.length,
          node;
      if (iterations === undefined) iterations = 1;

      for (var k = 0; k < iterations; ++k) {
        _alpha += (_alphaTarget - _alpha) * _alphaDecay;
        forces.forEach(function (force) {
          force(_alpha);
        });

        for (i = 0; i < n; ++i) {
          node = _nodes[i];
          if (node.fx == null) node.x += node.vx *= _velocityDecay;else node.x = node.fx, node.vx = 0;
          if (node.fy == null) node.y += node.vy *= _velocityDecay;else node.y = node.fy, node.vy = 0;
        }
      }

      return simulation;
    }

    function initializeNodes() {
      for (var i = 0, n = _nodes.length, node; i < n; ++i) {
        node = _nodes[i], node.index = i;
        if (node.fx != null) node.x = node.fx;
        if (node.fy != null) node.y = node.fy;

        if (isNaN(node.x) || isNaN(node.y)) {
          var radius = initialRadius * Math.sqrt(i),
              angle = i * initialAngle;
          node.x = radius * Math.cos(angle);
          node.y = radius * Math.sin(angle);
        }

        if (isNaN(node.vx) || isNaN(node.vy)) {
          node.vx = node.vy = 0;
        }
      }
    }

    function initializeForce(force) {
      if (force.initialize) force.initialize(_nodes);
      return force;
    }

    initializeNodes();
    return simulation = {
      tick: tick,
      restart: function restart() {
        return stepper.restart(step), simulation;
      },
      stop: function stop() {
        return stepper.stop(), simulation;
      },
      nodes: function nodes(_) {
        return arguments.length ? (_nodes = _, initializeNodes(), forces.forEach(initializeForce), simulation) : _nodes;
      },
      alpha: function alpha(_) {
        return arguments.length ? (_alpha = +_, simulation) : _alpha;
      },
      alphaMin: function alphaMin(_) {
        return arguments.length ? (_alphaMin = +_, simulation) : _alphaMin;
      },
      alphaDecay: function alphaDecay(_) {
        return arguments.length ? (_alphaDecay = +_, simulation) : +_alphaDecay;
      },
      alphaTarget: function alphaTarget(_) {
        return arguments.length ? (_alphaTarget = +_, simulation) : _alphaTarget;
      },
      velocityDecay: function velocityDecay(_) {
        return arguments.length ? (_velocityDecay = 1 - _, simulation) : 1 - _velocityDecay;
      },
      force: function force(name, _) {
        return arguments.length > 1 ? (_ == null ? forces["delete"](name) : forces.set(name, initializeForce(_)), simulation) : forces.get(name);
      },
      find: function find(x, y, radius) {
        var i = 0,
            n = _nodes.length,
            dx,
            dy,
            d2,
            node,
            closest;
        if (radius == null) radius = Infinity;else radius *= radius;

        for (i = 0; i < n; ++i) {
          node = _nodes[i];
          dx = x - node.x;
          dy = y - node.y;
          d2 = dx * dx + dy * dy;
          if (d2 < radius) closest = node, radius = d2;
        }

        return closest;
      },
      on: function on(name, _) {
        return arguments.length > 1 ? (event.on(name, _), simulation) : event.on(name);
      }
    };
  }

  function forceManyBody () {
    var nodes,
        node,
        alpha,
        strength = constant(-30),
        strengths,
        distanceMin2 = 1,
        distanceMax2 = Infinity,
        theta2 = 0.81;

    function force(_) {
      var i,
          n = nodes.length,
          tree = quadtree(nodes, x$1, y$1).visitAfter(accumulate);

      for (alpha = _, i = 0; i < n; ++i) {
        node = nodes[i], tree.visit(apply);
      }
    }

    function initialize() {
      if (!nodes) return;
      var i,
          n = nodes.length,
          node;
      strengths = new Array(n);

      for (i = 0; i < n; ++i) {
        node = nodes[i], strengths[node.index] = +strength(node, i, nodes);
      }
    }

    function accumulate(quad) {
      var strength = 0,
          q,
          c,
          weight = 0,
          x,
          y,
          i; // For internal nodes, accumulate forces from child quadrants.

      if (quad.length) {
        for (x = y = i = 0; i < 4; ++i) {
          if ((q = quad[i]) && (c = Math.abs(q.value))) {
            strength += q.value, weight += c, x += c * q.x, y += c * q.y;
          }
        }

        quad.x = x / weight;
        quad.y = y / weight;
      } // For leaf nodes, accumulate forces from coincident quadrants.
      else {
          q = quad;
          q.x = q.data.x;
          q.y = q.data.y;

          do {
            strength += strengths[q.data.index];
          } while (q = q.next);
        }

      quad.value = strength;
    }

    function apply(quad, x1, _, x2) {
      if (!quad.value) return true;
      var x = quad.x - node.x,
          y = quad.y - node.y,
          w = x2 - x1,
          l = x * x + y * y; // Apply the Barnes-Hut approximation if possible.
      // Limit forces for very close nodes; randomize direction if coincident.

      if (w * w / theta2 < l) {
        if (l < distanceMax2) {
          if (x === 0) x = jiggle(), l += x * x;
          if (y === 0) y = jiggle(), l += y * y;
          if (l < distanceMin2) l = Math.sqrt(distanceMin2 * l);
          node.vx += x * quad.value * alpha / l;
          node.vy += y * quad.value * alpha / l;
        }

        return true;
      } // Otherwise, process points directly.
      else if (quad.length || l >= distanceMax2) return; // Limit forces for very close nodes; randomize direction if coincident.


      if (quad.data !== node || quad.next) {
        if (x === 0) x = jiggle(), l += x * x;
        if (y === 0) y = jiggle(), l += y * y;
        if (l < distanceMin2) l = Math.sqrt(distanceMin2 * l);
      }

      do {
        if (quad.data !== node) {
          w = strengths[quad.data.index] * alpha / l;
          node.vx += x * w;
          node.vy += y * w;
        }
      } while (quad = quad.next);
    }

    force.initialize = function (_) {
      nodes = _;
      initialize();
    };

    force.strength = function (_) {
      return arguments.length ? (strength = typeof _ === "function" ? _ : constant(+_), initialize(), force) : strength;
    };

    force.distanceMin = function (_) {
      return arguments.length ? (distanceMin2 = _ * _, force) : Math.sqrt(distanceMin2);
    };

    force.distanceMax = function (_) {
      return arguments.length ? (distanceMax2 = _ * _, force) : Math.sqrt(distanceMax2);
    };

    force.theta = function (_) {
      return arguments.length ? (theta2 = _ * _, force) : Math.sqrt(theta2);
    };

    return force;
  }

  function forceRadial (radius, x, y) {
    var nodes,
        strength = constant(0.1),
        strengths,
        radiuses;
    if (typeof radius !== "function") radius = constant(+radius);
    if (x == null) x = 0;
    if (y == null) y = 0;

    function force(alpha) {
      for (var i = 0, n = nodes.length; i < n; ++i) {
        var node = nodes[i],
            dx = node.x - x || 1e-6,
            dy = node.y - y || 1e-6,
            r = Math.sqrt(dx * dx + dy * dy),
            k = (radiuses[i] - r) * strengths[i] * alpha / r;
        node.vx += dx * k;
        node.vy += dy * k;
      }
    }

    function initialize() {
      if (!nodes) return;
      var i,
          n = nodes.length;
      strengths = new Array(n);
      radiuses = new Array(n);

      for (i = 0; i < n; ++i) {
        radiuses[i] = +radius(nodes[i], i, nodes);
        strengths[i] = isNaN(radiuses[i]) ? 0 : +strength(nodes[i], i, nodes);
      }
    }

    force.initialize = function (_) {
      nodes = _, initialize();
    };

    force.strength = function (_) {
      return arguments.length ? (strength = typeof _ === "function" ? _ : constant(+_), initialize(), force) : strength;
    };

    force.radius = function (_) {
      return arguments.length ? (radius = typeof _ === "function" ? _ : constant(+_), initialize(), force) : radius;
    };

    force.x = function (_) {
      return arguments.length ? (x = +_, force) : x;
    };

    force.y = function (_) {
      return arguments.length ? (y = +_, force) : y;
    };

    return force;
  }

  function forceX (x) {
    var strength = constant(0.1),
        nodes,
        strengths,
        xz;
    if (typeof x !== "function") x = constant(x == null ? 0 : +x);

    function force(alpha) {
      for (var i = 0, n = nodes.length, node; i < n; ++i) {
        node = nodes[i], node.vx += (xz[i] - node.x) * strengths[i] * alpha;
      }
    }

    function initialize() {
      if (!nodes) return;
      var i,
          n = nodes.length;
      strengths = new Array(n);
      xz = new Array(n);

      for (i = 0; i < n; ++i) {
        strengths[i] = isNaN(xz[i] = +x(nodes[i], i, nodes)) ? 0 : +strength(nodes[i], i, nodes);
      }
    }

    force.initialize = function (_) {
      nodes = _;
      initialize();
    };

    force.strength = function (_) {
      return arguments.length ? (strength = typeof _ === "function" ? _ : constant(+_), initialize(), force) : strength;
    };

    force.x = function (_) {
      return arguments.length ? (x = typeof _ === "function" ? _ : constant(+_), initialize(), force) : x;
    };

    return force;
  }

  function forceY (y) {
    var strength = constant(0.1),
        nodes,
        strengths,
        yz;
    if (typeof y !== "function") y = constant(y == null ? 0 : +y);

    function force(alpha) {
      for (var i = 0, n = nodes.length, node; i < n; ++i) {
        node = nodes[i], node.vy += (yz[i] - node.y) * strengths[i] * alpha;
      }
    }

    function initialize() {
      if (!nodes) return;
      var i,
          n = nodes.length;
      strengths = new Array(n);
      yz = new Array(n);

      for (i = 0; i < n; ++i) {
        strengths[i] = isNaN(yz[i] = +y(nodes[i], i, nodes)) ? 0 : +strength(nodes[i], i, nodes);
      }
    }

    force.initialize = function (_) {
      nodes = _;
      initialize();
    };

    force.strength = function (_) {
      return arguments.length ? (strength = typeof _ === "function" ? _ : constant(+_), initialize(), force) : strength;
    };

    force.y = function (_) {
      return arguments.length ? (y = typeof _ === "function" ? _ : constant(+_), initialize(), force) : y;
    };

    return force;
  }

  function _createSuper$2(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$2(); return function _createSuperInternal() { var Super = getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct$2() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
  var ForceDirectedGraphController = /*#__PURE__*/function (_GraphController) {
    inherits(ForceDirectedGraphController, _GraphController);

    var _super = _createSuper$2(ForceDirectedGraphController);

    function ForceDirectedGraphController(chart, datasetIndex) {
      var _this;

      classCallCheck(this, ForceDirectedGraphController);

      _this = _super.call(this, chart, datasetIndex);
      _this._simulation = forceSimulation().on('tick', function () {
        _this._copyPosition();

        _this.chart.render();
      }).on('end', function () {
        _this._copyPosition();

        _this.chart.render();
      });
      var sim = _this._config.simulation;
      var fs = {
        center: forceCenter,
        collide: forceCollide,
        link: forceLink,
        manyBody: forceManyBody,
        x: forceX,
        y: forceY,
        radial: forceRadial
      };
      Object.keys(fs).forEach(function (key) {
        var options = sim.forces[key];

        if (!options) {
          return;
        }

        var f = fs[key]();

        if (typeof options !== 'boolean') {
          Object.keys(options).forEach(function (attr) {
            f[attr](options[attr]);
          });
        }

        _this._simulation.force(key, f);
      });

      _this._simulation.stop();

      return _this;
    }

    createClass(ForceDirectedGraphController, [{
      key: "_copyPosition",
      value: function _copyPosition() {
        var nodes = this._cachedMeta._parsed;
        var minmax = nodes.reduce(function (acc, v) {
          var s = v._sim;

          if (!s) {
            return acc;
          }

          if (s.x < acc.minX) {
            acc.minX = s.x;
          }

          if (s.x > acc.maxX) {
            acc.maxX = s.x;
          }

          if (s.y < acc.minY) {
            acc.minY = s.y;
          }

          if (s.y > acc.maxY) {
            acc.maxY = s.y;
          }

          return acc;
        }, {
          minX: Number.POSITIVE_INFINITY,
          maxX: Number.NEGATIVE_INFINITY,
          minY: Number.POSITIVE_INFINITY,
          maxY: Number.NEGATIVE_INFINITY
        });

        var rescaleX = function rescaleX(v) {
          return (v - minmax.minX) / (minmax.maxX - minmax.minX) * 2 - 1;
        };

        var rescaleY = function rescaleY(v) {
          return (v - minmax.minY) / (minmax.maxY - minmax.minY) * 2 - 1;
        };

        nodes.forEach(function (node) {
          if (node._sim) {
            node.x = rescaleX(node._sim.x);
            node.y = rescaleY(node._sim.y);
          }
        });
        var xScale = this._cachedMeta.xScale;
        var yScale = this._cachedMeta.yScale;
        var elems = this._cachedMeta.data;
        elems.forEach(function (elem, i) {
          var parsed = nodes[i];
          elem.x = xScale.getPixelForValue(parsed.x, i);
          elem.y = yScale.getPixelForValue(parsed.y, i);
        });
      }
    }, {
      key: "resetLayout",
      value: function resetLayout() {
        get(getPrototypeOf(ForceDirectedGraphController.prototype), "resetLayout", this).call(this);

        this._simulation.stop();

        var nodes = this._cachedMeta._parsed.map(function (node, i) {
          var simNode = Object.assign({}, node);
          simNode.index = i;
          node._sim = simNode;

          if (!node.reset) {
            return simNode;
          }

          delete simNode.x;
          delete simNode.y;
          delete simNode.vx;
          delete simNoe.vy;
          return simNode;
        });

        this._simulation.nodes(nodes);

        this._simulation.alpha(1).restart();
      }
    }, {
      key: "resyncLayout",
      value: function resyncLayout() {
        var _this2 = this;

        get(getPrototypeOf(ForceDirectedGraphController.prototype), "resyncLayout", this).call(this);

        this._simulation.stop();

        var meta = this._cachedMeta;

        var nodes = meta._parsed.map(function (node, i) {
          var simNode = Object.assign({}, node);
          simNode.index = i;
          node._sim = simNode;

          if (simNode.x === null) {
            delete simNode.x;
          }

          if (simNode.y === null) {
            delete simNode.y;
          }

          if (simNode.x == null && simNode.y == null) {
            node.reset = true;
          }

          return simNode;
        });

        var link = this._simulation.force('link');

        if (link) {
          link.links([]);
        }

        this._simulation.nodes(nodes);

        if (link) {
          // console.assert(ds.edges.length === meta.edges.length);
          // work on copy to avoid change
          link.links((meta._parsedEdges || []).map(function (link) {
            return Object.assign({}, link);
          }));
        }

        if (this._config.simulation.initialIterations > 0) {
          this._simulation.alpha(1);

          this._simulation.tick(this._config.simulation.initialIterations);

          this._copyPosition();

          if (this._config.simulation.autoRestart) {
            this._simulation.restart();
          } else {
            chartjsEsmFacade.requestAnimFrame.call(window, function () {
              return _this2.chart.update();
            });
          }
        } else if (this._config.simulation.autoRestart) {
          this._simulation.alpha(1).restart();
        }
      }
    }, {
      key: "reLayout",
      value: function reLayout() {
        this._simulation.alpha(1).restart();
      }
    }, {
      key: "stopLayout",
      value: function stopLayout() {
        get(getPrototypeOf(ForceDirectedGraphController.prototype), "stopLayout", this).call(this);

        this._simulation.stop();
      }
    }]);

    return ForceDirectedGraphController;
  }(GraphController);
  ForceDirectedGraphController.id = 'forceDirectedGraph';
  ForceDirectedGraphController.defaults = /*#__PURE__*/chartjsEsmFacade.merge({}, [GraphController.defaults, {
    animation: false,
    datasets: {
      simulation: {
        initialIterations: 0,
        autoRestart: true,
        forces: {
          center: true,
          collide: false,
          link: true,
          manyBody: true,
          x: false,
          y: false,
          radial: false
        }
      }
    },
    scales: {
      x: {
        min: -1,
        max: 1
      },
      y: {
        min: -1,
        max: 1
      }
    }
  }]);
  var ForceDirectedGraphChart = /*#__PURE__*/function (_Chart) {
    inherits(ForceDirectedGraphChart, _Chart);

    var _super2 = _createSuper$2(ForceDirectedGraphChart);

    function ForceDirectedGraphChart(item, config) {
      classCallCheck(this, ForceDirectedGraphChart);

      return _super2.call(this, item, patchController(config, ForceDirectedGraphController, [EdgeLine, chartjsEsmFacade.Point], chartjsEsmFacade.LinearScale));
    }

    return ForceDirectedGraphChart;
  }(chartjsEsmFacade.Chart);
  ForceDirectedGraphChart.id = ForceDirectedGraphController.id;

  function defaultSeparation(a, b) {
    return a.parent === b.parent ? 1 : 2;
  }

  function meanX(children) {
    return children.reduce(meanXReduce, 0) / children.length;
  }

  function meanXReduce(x, c) {
    return x + c.x;
  }

  function maxY(children) {
    return 1 + children.reduce(maxYReduce, 0);
  }

  function maxYReduce(y, c) {
    return Math.max(y, c.y);
  }

  function leafLeft(node) {
    var children;

    while (children = node.children) {
      node = children[0];
    }

    return node;
  }

  function leafRight(node) {
    var children;

    while (children = node.children) {
      node = children[children.length - 1];
    }

    return node;
  }

  function cluster () {
    var separation = defaultSeparation,
        dx = 1,
        dy = 1,
        nodeSize = false;

    function cluster(root) {
      var previousNode,
          x = 0; // First walk, computing the initial x & y values.

      root.eachAfter(function (node) {
        var children = node.children;

        if (children) {
          node.x = meanX(children);
          node.y = maxY(children);
        } else {
          node.x = previousNode ? x += separation(node, previousNode) : 0;
          node.y = 0;
          previousNode = node;
        }
      });
      var left = leafLeft(root),
          right = leafRight(root),
          x0 = left.x - separation(left, right) / 2,
          x1 = right.x + separation(right, left) / 2; // Second walk, normalizing x & y to the desired size.

      return root.eachAfter(nodeSize ? function (node) {
        node.x = (node.x - root.x) * dx;
        node.y = (root.y - node.y) * dy;
      } : function (node) {
        node.x = (node.x - x0) / (x1 - x0) * dx;
        node.y = (1 - (root.y ? node.y / root.y : 1)) * dy;
      });
    }

    cluster.separation = function (x) {
      return arguments.length ? (separation = x, cluster) : separation;
    };

    cluster.size = function (x) {
      return arguments.length ? (nodeSize = false, dx = +x[0], dy = +x[1], cluster) : nodeSize ? null : [dx, dy];
    };

    cluster.nodeSize = function (x) {
      return arguments.length ? (nodeSize = true, dx = +x[0], dy = +x[1], cluster) : nodeSize ? [dx, dy] : null;
    };

    return cluster;
  }

  function count(node) {
    var sum = 0,
        children = node.children,
        i = children && children.length;
    if (!i) sum = 1;else while (--i >= 0) {
      sum += children[i].value;
    }
    node.value = sum;
  }

  function node_count () {
    return this.eachAfter(count);
  }

  function node_each (callback) {
    var node = this,
        current,
        next = [node],
        children,
        i,
        n;

    do {
      current = next.reverse(), next = [];

      while (node = current.pop()) {
        callback(node), children = node.children;
        if (children) for (i = 0, n = children.length; i < n; ++i) {
          next.push(children[i]);
        }
      }
    } while (next.length);

    return this;
  }

  function node_eachBefore (callback) {
    var node = this,
        nodes = [node],
        children,
        i;

    while (node = nodes.pop()) {
      callback(node), children = node.children;
      if (children) for (i = children.length - 1; i >= 0; --i) {
        nodes.push(children[i]);
      }
    }

    return this;
  }

  function node_eachAfter (callback) {
    var node = this,
        nodes = [node],
        next = [],
        children,
        i,
        n;

    while (node = nodes.pop()) {
      next.push(node), children = node.children;
      if (children) for (i = 0, n = children.length; i < n; ++i) {
        nodes.push(children[i]);
      }
    }

    while (node = next.pop()) {
      callback(node);
    }

    return this;
  }

  function node_sum (value) {
    return this.eachAfter(function (node) {
      var sum = +value(node.data) || 0,
          children = node.children,
          i = children && children.length;

      while (--i >= 0) {
        sum += children[i].value;
      }

      node.value = sum;
    });
  }

  function node_sort (compare) {
    return this.eachBefore(function (node) {
      if (node.children) {
        node.children.sort(compare);
      }
    });
  }

  function node_path (end) {
    var start = this,
        ancestor = leastCommonAncestor(start, end),
        nodes = [start];

    while (start !== ancestor) {
      start = start.parent;
      nodes.push(start);
    }

    var k = nodes.length;

    while (end !== ancestor) {
      nodes.splice(k, 0, end);
      end = end.parent;
    }

    return nodes;
  }

  function leastCommonAncestor(a, b) {
    if (a === b) return a;
    var aNodes = a.ancestors(),
        bNodes = b.ancestors(),
        c = null;
    a = aNodes.pop();
    b = bNodes.pop();

    while (a === b) {
      c = a;
      a = aNodes.pop();
      b = bNodes.pop();
    }

    return c;
  }

  function node_ancestors () {
    var node = this,
        nodes = [node];

    while (node = node.parent) {
      nodes.push(node);
    }

    return nodes;
  }

  function node_descendants () {
    var nodes = [];
    this.each(function (node) {
      nodes.push(node);
    });
    return nodes;
  }

  function node_leaves () {
    var leaves = [];
    this.eachBefore(function (node) {
      if (!node.children) {
        leaves.push(node);
      }
    });
    return leaves;
  }

  function node_links () {
    var root = this,
        links = [];
    root.each(function (node) {
      if (node !== root) {
        // Don’t include the root’s parent, if any.
        links.push({
          source: node.parent,
          target: node
        });
      }
    });
    return links;
  }

  function hierarchy(data, children) {
    var root = new Node(data),
        valued = +data.value && (root.value = data.value),
        node,
        nodes = [root],
        child,
        childs,
        i,
        n;
    if (children == null) children = defaultChildren;

    while (node = nodes.pop()) {
      if (valued) node.value = +node.data.value;

      if ((childs = children(node.data)) && (n = childs.length)) {
        node.children = new Array(n);

        for (i = n - 1; i >= 0; --i) {
          nodes.push(child = node.children[i] = new Node(childs[i]));
          child.parent = node;
          child.depth = node.depth + 1;
        }
      }
    }

    return root.eachBefore(computeHeight);
  }

  function node_copy() {
    return hierarchy(this).eachBefore(copyData);
  }

  function defaultChildren(d) {
    return d.children;
  }

  function copyData(node) {
    node.data = node.data.data;
  }

  function computeHeight(node) {
    var height = 0;

    do {
      node.height = height;
    } while ((node = node.parent) && node.height < ++height);
  }
  function Node(data) {
    this.data = data;
    this.depth = this.height = 0;
    this.parent = null;
  }
  Node.prototype = hierarchy.prototype = {
    constructor: Node,
    count: node_count,
    each: node_each,
    eachAfter: node_eachAfter,
    eachBefore: node_eachBefore,
    sum: node_sum,
    sort: node_sort,
    path: node_path,
    ancestors: node_ancestors,
    descendants: node_descendants,
    leaves: node_leaves,
    links: node_links,
    copy: node_copy
  };

  function defaultSeparation$1(a, b) {
    return a.parent === b.parent ? 1 : 2;
  } // function radialSeparation(a, b) {
  //   return (a.parent === b.parent ? 1 : 2) / a.depth;
  // }
  // This function is used to traverse the left contour of a subtree (or
  // subforest). It returns the successor of v on this contour. This successor is
  // either given by the leftmost child of v or by the thread of v. The function
  // returns null if and only if v is on the highest level of its subtree.


  function nextLeft(v) {
    var children = v.children;
    return children ? children[0] : v.t;
  } // This function works analogously to nextLeft.


  function nextRight(v) {
    var children = v.children;
    return children ? children[children.length - 1] : v.t;
  } // Shifts the current subtree rooted at w+. This is done by increasing
  // prelim(w+) and mod(w+) by shift.


  function moveSubtree(wm, wp, shift) {
    var change = shift / (wp.i - wm.i);
    wp.c -= change;
    wp.s += shift;
    wm.c += change;
    wp.z += shift;
    wp.m += shift;
  } // All other shifts, applied to the smaller subtrees between w- and w+, are
  // performed by this function. To prepare the shifts, we have to adjust
  // change(w+), shift(w+), and change(w-).


  function executeShifts(v) {
    var shift = 0,
        change = 0,
        children = v.children,
        i = children.length,
        w;

    while (--i >= 0) {
      w = children[i];
      w.z += shift;
      w.m += shift;
      shift += w.s + (change += w.c);
    }
  } // If vi-’s ancestor is a sibling of v, returns vi-’s ancestor. Otherwise,
  // returns the specified (default) ancestor.


  function nextAncestor(vim, v, ancestor) {
    return vim.a.parent === v.parent ? vim.a : ancestor;
  }

  function TreeNode(node, i) {
    this._ = node;
    this.parent = null;
    this.children = null;
    this.A = null; // default ancestor

    this.a = this; // ancestor

    this.z = 0; // prelim

    this.m = 0; // mod

    this.c = 0; // change

    this.s = 0; // shift

    this.t = null; // thread

    this.i = i; // number
  }

  TreeNode.prototype = Object.create(Node.prototype);

  function treeRoot(root) {
    var tree = new TreeNode(root, 0),
        node,
        nodes = [tree],
        child,
        children,
        i,
        n;

    while (node = nodes.pop()) {
      if (children = node._.children) {
        node.children = new Array(n = children.length);

        for (i = n - 1; i >= 0; --i) {
          nodes.push(child = node.children[i] = new TreeNode(children[i], i));
          child.parent = node;
        }
      }
    }

    (tree.parent = new TreeNode(null, 0)).children = [tree];
    return tree;
  } // Node-link tree diagram using the Reingold-Tilford "tidy" algorithm


  function tree () {
    var separation = defaultSeparation$1,
        dx = 1,
        dy = 1,
        nodeSize = null;

    function tree(root) {
      var t = treeRoot(root); // Compute the layout using Buchheim et al.’s algorithm.

      t.eachAfter(firstWalk), t.parent.m = -t.z;
      t.eachBefore(secondWalk); // If a fixed node size is specified, scale x and y.

      if (nodeSize) root.eachBefore(sizeNode); // If a fixed tree size is specified, scale x and y based on the extent.
      // Compute the left-most, right-most, and depth-most nodes for extents.
      else {
          var left = root,
              right = root,
              bottom = root;
          root.eachBefore(function (node) {
            if (node.x < left.x) left = node;
            if (node.x > right.x) right = node;
            if (node.depth > bottom.depth) bottom = node;
          });
          var s = left === right ? 1 : separation(left, right) / 2,
              tx = s - left.x,
              kx = dx / (right.x + s + tx),
              ky = dy / (bottom.depth || 1);
          root.eachBefore(function (node) {
            node.x = (node.x + tx) * kx;
            node.y = node.depth * ky;
          });
        }
      return root;
    } // Computes a preliminary x-coordinate for v. Before that, FIRST WALK is
    // applied recursively to the children of v, as well as the function
    // APPORTION. After spacing out the children by calling EXECUTE SHIFTS, the
    // node v is placed to the midpoint of its outermost children.


    function firstWalk(v) {
      var children = v.children,
          siblings = v.parent.children,
          w = v.i ? siblings[v.i - 1] : null;

      if (children) {
        executeShifts(v);
        var midpoint = (children[0].z + children[children.length - 1].z) / 2;

        if (w) {
          v.z = w.z + separation(v._, w._);
          v.m = v.z - midpoint;
        } else {
          v.z = midpoint;
        }
      } else if (w) {
        v.z = w.z + separation(v._, w._);
      }

      v.parent.A = apportion(v, w, v.parent.A || siblings[0]);
    } // Computes all real x-coordinates by summing up the modifiers recursively.


    function secondWalk(v) {
      v._.x = v.z + v.parent.m;
      v.m += v.parent.m;
    } // The core of the algorithm. Here, a new subtree is combined with the
    // previous subtrees. Threads are used to traverse the inside and outside
    // contours of the left and right subtree up to the highest common level. The
    // vertices used for the traversals are vi+, vi-, vo-, and vo+, where the
    // superscript o means outside and i means inside, the subscript - means left
    // subtree and + means right subtree. For summing up the modifiers along the
    // contour, we use respective variables si+, si-, so-, and so+. Whenever two
    // nodes of the inside contours conflict, we compute the left one of the
    // greatest uncommon ancestors using the function ANCESTOR and call MOVE
    // SUBTREE to shift the subtree and prepare the shifts of smaller subtrees.
    // Finally, we add a new thread (if necessary).


    function apportion(v, w, ancestor) {
      if (w) {
        var vip = v,
            vop = v,
            vim = w,
            vom = vip.parent.children[0],
            sip = vip.m,
            sop = vop.m,
            sim = vim.m,
            som = vom.m,
            shift;

        while (vim = nextRight(vim), vip = nextLeft(vip), vim && vip) {
          vom = nextLeft(vom);
          vop = nextRight(vop);
          vop.a = v;
          shift = vim.z + sim - vip.z - sip + separation(vim._, vip._);

          if (shift > 0) {
            moveSubtree(nextAncestor(vim, v, ancestor), v, shift);
            sip += shift;
            sop += shift;
          }

          sim += vim.m;
          sip += vip.m;
          som += vom.m;
          sop += vop.m;
        }

        if (vim && !nextRight(vop)) {
          vop.t = vim;
          vop.m += sim - sop;
        }

        if (vip && !nextLeft(vom)) {
          vom.t = vip;
          vom.m += sip - som;
          ancestor = v;
        }
      }

      return ancestor;
    }

    function sizeNode(node) {
      node.x *= dx;
      node.y = node.depth * dy;
    }

    tree.separation = function (x) {
      return arguments.length ? (separation = x, tree) : separation;
    };

    tree.size = function (x) {
      return arguments.length ? (nodeSize = false, dx = +x[0], dy = +x[1], tree) : nodeSize ? null : [dx, dy];
    };

    tree.nodeSize = function (x) {
      return arguments.length ? (nodeSize = true, dx = +x[0], dy = +x[1], tree) : nodeSize ? [dx, dy] : null;
    };

    return tree;
  }

  function _createSuper$3(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$3(); return function _createSuperInternal() { var Super = getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct$3() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
  var DendogramController = /*#__PURE__*/function (_GraphController) {
    inherits(DendogramController, _GraphController);

    var _super = _createSuper$3(DendogramController);

    function DendogramController() {
      classCallCheck(this, DendogramController);

      return _super.apply(this, arguments);
    }

    createClass(DendogramController, [{
      key: "updateEdgeElement",
      value: function updateEdgeElement(line, index, properties, mode) {
        properties._orientation = this._config.tree.orientation;

        get(getPrototypeOf(DendogramController.prototype), "updateEdgeElement", this).call(this, line, index, properties, mode);
      }
    }, {
      key: "updateElement",
      value: function updateElement(point, index, properties, mode) {
        if (index != null) {
          properties.angle = this.getParsed(index).angle;
        }

        get(getPrototypeOf(DendogramController.prototype), "updateElement", this).call(this, point, index, properties, mode);
      }
    }, {
      key: "resyncLayout",
      value: function resyncLayout() {
        var _this = this;

        var meta = this._cachedMeta;
        meta.root = hierarchy(this.getTreeRoot(), function (d) {
          return _this.getTreeChildren(d);
        }).count().sort(function (a, b) {
          return b.height - a.height || b.data.index - a.data.index;
        });
        this.doLayout(meta.root);

        get(getPrototypeOf(DendogramController.prototype), "resyncLayout", this).call(this);
      }
    }, {
      key: "reLayout",
      value: function reLayout(newOptions) {
        if (newOptions) {
          Object.assign(this._config.tree, newOptions);
          var ds = this.getDataset();

          if (ds.tree) {
            Object.assign(ds.tree, newOptions);
          } else {
            ds.tree = newOptions;
          }
        }

        this.doLayout(this._cachedMeta.root);
      }
    }, {
      key: "doLayout",
      value: function doLayout(root) {
        var _this2 = this;

        var options = this._config.tree;
        var layout = options.mode === 'tree' ? tree() : cluster();

        if (options.orientation === 'radial') {
          layout.size([Math.PI * 2, 1]);
        } else {
          layout.size([2, 2]);
        }

        var orientation = {
          horizontal: function horizontal(d) {
            d.data.x = d.y - 1;
            d.data.y = -d.x + 1;
          },
          vertical: function vertical(d) {
            d.data.x = d.x - 1;
            d.data.y = -d.y + 1;
          },
          radial: function radial(d) {
            d.data.x = Math.cos(d.x) * d.y;
            d.data.y = Math.sin(d.x) * d.y;
            d.data.angle = d.y === 0 ? Number.NaN : d.x;
          }
        };
        layout(root).each(orientation[options.orientation] || orientation.horizontal);
        chartjsEsmFacade.requestAnimFrame.call(window, function () {
          return _this2.chart.update();
        });
      }
    }]);

    return DendogramController;
  }(GraphController);
  DendogramController.id = 'dendogram';
  DendogramController.defaults = /*#__PURE__*/chartjsEsmFacade.merge({}, [GraphController.defaults, {
    datasets: {
      tree: {
        mode: 'dendogram',
        // dendogram, tree
        orientation: 'horizontal' // vertical, horizontal, radial

      },
      animation: {
        numbers: {
          type: 'number',
          properties: ['x', 'y', 'angle', 'radius', 'rotation', 'borderWidth']
        }
      },
      tension: 0.4
    },
    scales: {
      x: {
        min: -1,
        max: 1
      },
      y: {
        min: -1,
        max: 1
      }
    }
  }]);
  var DendogramChart = /*#__PURE__*/function (_Chart) {
    inherits(DendogramChart, _Chart);

    var _super2 = _createSuper$3(DendogramChart);

    function DendogramChart(item, config) {
      classCallCheck(this, DendogramChart);

      return _super2.call(this, item, patchController(config, DendogramController, EdgeLine));
    }

    return DendogramChart;
  }(chartjsEsmFacade.Chart);
  DendogramChart.id = DendogramController.id;
  var TreeController = /*#__PURE__*/function (_DendogramController) {
    inherits(TreeController, _DendogramController);

    var _super3 = _createSuper$3(TreeController);

    function TreeController() {
      classCallCheck(this, TreeController);

      return _super3.apply(this, arguments);
    }

    return TreeController;
  }(DendogramController);
  TreeController.id = 'tree';
  TreeController.defaults = /*#__PURE__*/chartjsEsmFacade.merge({}, [DendogramController.defaults, {
    datasets: {
      tree: {
        mode: 'tree'
      }
    }
  }]);
  var TreeChart = /*#__PURE__*/function (_Chart2) {
    inherits(TreeChart, _Chart2);

    var _super4 = _createSuper$3(TreeChart);

    function TreeChart(item, config) {
      classCallCheck(this, TreeChart);

      return _super4.call(this, item, patchController(config, TreeController, [EdgeLine, chartjsEsmFacade.Point], chartjsEsmFacade.LinearScale));
    }

    return TreeChart;
  }(chartjsEsmFacade.Chart);
  TreeChart.id = TreeController.id;

  chartjsEsmFacade.registry.addControllers(DendogramController, ForceDirectedGraphController, GraphController, TreeController);
  chartjsEsmFacade.registry.addElements(EdgeLine);

  exports.DendogramChart = DendogramChart;
  exports.DendogramController = DendogramController;
  exports.EdgeLine = EdgeLine;
  exports.ForceDirectedGraphChart = ForceDirectedGraphChart;
  exports.ForceDirectedGraphController = ForceDirectedGraphController;
  exports.GraphChart = GraphChart;
  exports.GraphController = GraphController;
  exports.TreeChart = TreeChart;
  exports.TreeController = TreeController;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
